image: node:22

stages:
    - lint
    - publish

cache:
    paths:
        - node_modules/

before_script:
    - npm ci

eslint:
    stage: lint
    script:
        - npm run lint

spellcheck:
    stage: lint
    script:
        - npm run spellcheck

publish:staging:
    # Configure what tag to use for this publication.
    variables:
        NPM_TAG: 'development'

    before_script:
        # add the NPM_TAG to the version field in the package file during this script
        - sed -i -r "/version/s/([0-9\.]+)/\1-${NPM_TAG}.${CI_JOB_ID}/g" package.json

    only:
        - development

    # Use the common template to publish the library.
    extends: .publish_to_npm

publish:production:
    # Configure what tag to use for this publication.
    variables:
        NPM_TAG: 'latest'

    # Only run this on the version tags:
    # NOTE: format looks like "v2", "v2.0", "v2.0.0" or "v2.0.0-revision"
    rules:
        - if: '$CI_COMMIT_TAG =~ /^v([0-9]+)(\.[0-9]+)+(\-[a-z0-9]+)?$/'

    # Use the common template to publish the library.
    extends: .publish_to_npm

.publish_to_npm:
    # Configure which stage in the pipeline this part should be run in.
    stage: publish

    script:
        - npm config set //registry.npmjs.org/:_authToken ${NPM_AUTH_TOKEN}
        - npm publish --tag ${NPM_TAG}
